import es, playerlib, popuplib, gamethread, services, cfglib, keyvalues

atcfg = cfglib.AddonCFG(es.getAddonPath("admin_teleport") + "/config.cfg")
global_msg = atcfg.cvar('global_msg', "1", 'If 1, will send global message when teleport is used. Otherwise uses player messages')
mani_support = atcfg.cvar('mani_support', "off", 'If on, will use mani to get admin list. If off, it will use ES\'s Auth System')
atcfg.write()

info = es.AddonInfo()
info['name'] = "Admin Teleport"
info['basename'] = "admin_teleport"
info['version'] = "1.9"
info['author'] = "Undead"
info['url'] = "http://forums.mattie.info/cs/forums/viewtopic.php?p=257704"
info['description'] = "Advanced Admin Teleport System"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

dict_teleport = {}
dict_auto = {}
admin_list = []

isAuthed = lambda userid: False

def load():
  global teleport_menu, isAuthed, admin_list
  atcfg.execute()
  if mani_support == 'on':
    es.keygroupcreate("clients")
    clients = keyvalues.getKeyGroup("clients")
    clients.load("cfg/mani_admin_plugin/clients.txt")
    admin_list = [x['steam'] for x in clients['players']]
    es.dbgmsg(0, admin_list)
  else:
    if services.isRegistered('auth'):
      auth = services.use('auth')
      auth.registerCapability('teleport', auth.POWERUSER)
      isAuthed = lambda userid: auth.isUseridAuthorized(userid, 'teleport')
      es.dbgmsg(0, 'Auth Enabled')
  if not es.exists('saycommand', '!teleport'):
    es.regsaycmd('!teleport', 'admin_teleport/teleport_cmd')
  for user in es.getUseridList():
    steamid = es.getplayersteamid(user)
    dict_add_player(user, steamid)
  es.msg('#multi', '#default[#greenTeleport#default] by #lightgreenUndead #defaulthas been loaded!')

def teleport_cmd():
  userid = es.getcmduserid()
  user = userid
  if es.getplayersteamid(userid) in admin_list or isAuthed(user):
    teleport_menu = popuplib.easymenu('tele_%s'%userid, '_popup_choice', teleport_menu_select)
    teleport_menu.settitle("Select Teleport Option:")
    teleport_menu.addoption('1', "Teleport To Player")
    teleport_menu.addoption('2', "Teleport Player To Me")
    teleport_menu.addoption('3', "Save Spot for Teleport")
    teleport_menu.addoption('4', "Teleport To Saved Spot")
    teleport_menu.addoption('5', "Teleport Other To Saved Spot")
    teleport_menu.addoption('6', "Teleport A Player to Another")
    if dict_auto[user]["status"] == 0:
      if dict_teleport[user]["loc1"] != 0 or dict_teleport[user]["loc2"] != 0 or dict_teleport[user]["loc3"] != 0:
        teleport_menu.addoption('7', "Enable: Auto-Tele on Round Start")
    elif dict_auto[user]["status"] != 0:
      teleport_menu.addoption('7', "Disable: Auto-Tele on Round Start")
    popuplib.send('tele_%s'%userid, userid)
  else: es.tell(userid, 'You are not an admin!')

def teleport_menu_select(userid, choice, popupid):
  global dict_teleport, dict_auto
  user = int(userid)
  if choice == '1':
    target_list = popuplib.construct('target_list', 'players', '#alive', target_list_select)
    target_list.settitle("Select a Player:")
    popuplib.send('target_list', userid)
  elif choice == '2':
    target_list2 = popuplib.construct('target_list2', 'players', '#alive', target_list2_select)
    target_list2.settitle("Select a Player:")
    popuplib.send('target_list2', userid)
  elif choice == '3':
    save_menu = popuplib.easymenu('save_menu', '_popup_choice', save_menu_select)
    save_menu.settitle("Select Slot To Use:")
    if dict_teleport[user]["loc1"] == 0:
      save_menu.addoption('1', "Slot 1")
    else:
      save_menu.addoption('1', "Spot 1 - %s %s %s"%dict_teleport[user]["loc1"])
    if dict_teleport[user]["loc2"] == 0:
      save_menu.addoption('2', "Slot 2")
    else:
      save_menu.addoption('2', "Spot 2 - %s %s %s"%dict_teleport[user]["loc2"])
    if dict_teleport[user]["loc3"] == 0:
      save_menu.addoption('3', "Slot 3")
    else:
      save_menu.addoption('3', "Spot 3 - %s %s %s"%dict_teleport[user]["loc3"])
    save_menu.send(user)
  elif choice == '4':
    if dict_teleport[user]["loc1"] != 0 or dict_teleport[user]["loc2"] != 0 or dict_teleport[user]["loc3"] != 0:
      save_menu2 = popuplib.easymenu('save_menu2', '_popup_choice', save_menu2_select)
      save_menu2.settitle("Select Spot:")
      if dict_teleport[user]["loc1"] != 0:
        save_menu2.addoption('1', "Spot 1 - %s %s %s"%dict_teleport[user]["loc1"])
      if dict_teleport[user]["loc2"] != 0:
        save_menu2.addoption('2', "Spot 2 - %s %s %s"%dict_teleport[user]["loc2"])
      if dict_teleport[user]["loc3"] != 0:
        save_menu2.addoption('3', "Spot 3 - %s %s %s"%dict_teleport[user]["loc3"])
      save_menu2.send(user)
    else: es.tell(user, '#multi', '#default[#greenTeleport#default]: You don\'t have a Saved Spot!')
  elif choice == '5':
    target_list3 = popuplib.construct('target_list3', 'players', '#alive', target_list3_select)
    target_list3.settitle("Select a Player:")
    popuplib.send('target_list3', user)
  elif choice == '6':
    target_list4 = popuplib.construct('target_list4', 'players', '#alive', target_list4_select)
    target_list4.settitle("Player To Teleport To:")
    popuplib.send('target_list4', user)
  elif choice == '7':
    if dict_teleport[user]["loc1"] != 0 or dict_teleport[user]["loc2"] != 0 or dict_teleport[user]["loc3"] != 0:
      if dict_auto[user]["status"] == 0:
        save_menu4 = popuplib.easymenu('save_menu4', '_popup_choice', save_menu4_select)
        save_menu4.settitle("Select Spot:")
        if dict_teleport[user]["loc1"] != 0:
          save_menu4.addoption('1', "Spot 1 - %s %s %s"%dict_teleport[user]["loc1"])
        if dict_teleport[user]["loc2"] != 0:
          save_menu4.addoption('2', "Spot 2 - %s %s %s"%dict_teleport[user]["loc2"])
        if dict_teleport[user]["loc3"] != 0:
          save_menu4.addoption('3', "Spot 3 - %s %s %s"%dict_teleport[user]["loc3"])
        save_menu4.send(user)
      else:
        dict_auto[user]["status"] = 0
        es.tell(user, '#multi', '#default[#greenTeleport#default]: You will not be Auto-Teleported each round to your Saved Spot!')
    else: es.tell(user, '#multi', '#default[#greenTeleport#default]: You don\'t have a Saved Spot!')
  if popuplib.exists('tele_%s'%user):
    popuplib.delete('tele_%s'%user)

def save_menu_select(userid, choice, popupid):
  if choice == '1':
    dict_teleport[userid]["loc1"] = es.getplayerlocation(userid)
    es.tell(userid, '#multi', '#default[#greenTeleport#default]: Slot 1 Saved To #lightgreen%s %s %s#default!'%es.getplayerlocation(userid))
  elif choice == '2':
    dict_teleport[userid]["loc2"] = es.getplayerlocation(userid)
    es.tell(userid, '#multi', '#default[#greenTeleport#default]: Slot 2 Saved To #lightgreen%s %s %s#default!'%es.getplayerlocation(userid))
  elif choice == '3':
    dict_teleport[userid]["loc3"] = es.getplayerlocation(userid)
    es.tell(userid, '#multi', '#default[#greenTeleport#default]: Slot 3 Saved To #lightgreen%s %s %s#default!'%es.getplayerlocation(userid))
  popuplib.delete('save_menu')

def save_menu2_select(userid, choice, popupid):
  if choice == '1':
    es.server.queuecmd('es_setpos %s %s %s %s'%(userid, dict_teleport[userid]["loc1"][0], dict_teleport[userid]["loc1"][1], dict_teleport[userid]["loc1"][2]))
  elif choice == '2':
    es.server.queuecmd('es_setpos %s %s %s %s'%(userid, dict_teleport[userid]["loc2"][0], dict_teleport[userid]["loc2"][1], dict_teleport[userid]["loc2"][2]))
  elif choice == '3':
    es.server.queuecmd('es_setpos %s %s %s %s'%(userid, dict_teleport[userid]["loc3"][0], dict_teleport[userid]["loc3"][1], dict_teleport[userid]["loc3"][2]))
  if global_msg == 1:
    es.msg('#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported to Saved Spot!'%es.getplayername(userid))
  else:
    es.tell(userid, '#multi', '#default[#greenTeleport#default]: Teleported to Saved Spot!')

def save_menu4_select(userid, choice, popupid):
  global dict_auto
  if dict_auto[userid]["status"] == 0:
    if choice == '1':
      dict_auto[userid]["status"] = 1
    elif choice == '2':
      dict_auto[userid]["status"] = 2
    elif choice == '3':
      dict_auto[userid]["status"] = 3
  es.tell(userid, '#multi', '#default[#greenTeleport#default]: You will now be Auto-Teleported each round to your Saved Spot!')
  popuplib.delete('save_menu4')

def target_list_select(userid, choice, popupid):
  user = int(userid)
  user2 = int(choice)
  es.server.queuecmd('es_setpos %s %s %s %s'%(user, es.getplayerlocation(user2)[0], es.getplayerlocation(user2)[1], es.getplayerlocation(user2)[2]))
  es.setplayerprop(user, 'CBaseEntity.m_CollisionGroup', 2)
  es.setplayerprop(user2, 'CBaseEntity.m_CollisionGroup', 2)
  if global_msg == 1:
    es.msg('#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported to #lightgreen%s#default!'%(es.getplayername(user),es.getplayername(user2)))
  else:
    es.tell(int(choice), '#multi', '#default[#greenTeleport#default]: #lightgreen%s was teleported to you!'%es.getplayername(user))
    es.tell(int(userid), '#multi', '#default[#greenTeleport#default]: You teleported to #lightgreen%s#default!'%es.getplayername(user2))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list')

def target_list2_select(userid, choice, popupid):
  user = int(userid)
  user2 = int(choice)
  es.server.queuecmd('es_setpos %s %s %s %s'%(user2, es.getplayerlocation(user)[0], es.getplayerlocation(user)[1], es.getplayerlocation(user)[2]))
  es.setplayerprop(user, 'CBaseEntity.m_CollisionGroup', 2)
  es.setplayerprop(user2, 'CBaseEntity.m_CollisionGroup', 2)
  if global_msg == 1:
    es.msg('#multi', '#default[#greenTeleport#default]: #lightgreen%s #defaultteleported to Admin #lightgreen%s#default!'%(es.getplayername(user2),es.getplayername(user)))
  else:
    es.tell(int(choice), '#multi', '#default[#greenTeleport#default]: You were teleported to and by #lightgreen%s#default!'%es.getplayername(user))
    es.tell(int(userid), '#multi', '#default[#greenTeleport#default]: #lightgreen%s #defaultteleported to you!'%es.getplayername(user2))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list2')

def target_list3_select(userid, choice, popupid):
  global dict_teleport
  user = int(userid)
  if dict_teleport[user]["loc1"] != 0 or dict_teleport[user]["loc2"] != 0 or dict_teleport[user]["loc3"] != 0:
    save_menu3 = popuplib.easymenu('save_menu3', '_popup_choice', save_menu3_select)
    save_menu3.settitle("Select Spot:")
    if dict_teleport[user]["loc1"] != 0:
      save_menu3.addoption('1', "Spot 1 - %s %s %s"%dict_teleport[user]["loc1"])
      dict_teleport[user]["player"] = choice
    if dict_teleport[user]["loc2"] != 0:
      save_menu3.addoption('2', "Spot 2 - %s %s %s"%dict_teleport[user]["loc2"])
      dict_teleport[user]["player"] = choice
    if dict_teleport[user]["loc3"] != 0:
      save_menu3.addoption('3', "Spot 3 - %s %s %s"%dict_teleport[user]["loc3"])
      dict_teleport[user]["player"] = choice
    save_menu3.send(user)
  else: es.tell(user, '#multi', '#default[#greenTeleport#default]: You don\'t have a Saved Spot!')
  popuplib.delete('target_list3')

def save_menu3_select(userid, choice, popupid):
  user = int(userid)
  user_to_tele = dict_teleport[user]["player"]
  if choice == '1':
    if dict_teleport[user]["loc1"] != 0:
      es.server.queuecmd('es_setpos %s %s %s %s' % (user_to_tele, dict_teleport[user]["loc1"][0], dict_teleport[user]["loc1"][1], dict_teleport[user]["loc1"][2])) 
  elif choice == '2':
    if dict_teleport[user]["loc2"] != 0:
      es.server.queuecmd('es_setpos %s %s %s %s' % (user_to_tele, dict_teleport[user]["loc2"][0], dict_teleport[user]["loc2"][1], dict_teleport[user]["loc2"][2]))
  elif choice == '3':
    if dict_teleport[user]["loc3"] != 0:
      es.server.queuecmd('es_setpos %s %s %s %s' % (user_to_tele, dict_teleport[user]["loc3"][0], dict_teleport[user]["loc3"][1], dict_teleport[user]["loc3"][2])) 
  if global_msg == 1:
    es.msg('#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported #lightgreen%s #defaultto Saved Spot!'%(es.getplayername(user),es.getplayername(int(user_to_tele))))
  else:
    es.tell(int(choice), '#multi', '#default[#greenTeleport#default]: You have been teleported by #lightgreen%s#default!'%es.getplayername(user))
    es.tell(user, '#multi', '#default[#greenTeleport#default]: You have teleported #lightgreen%s #defaultto Saved Spot!'%es.getplayername(int(user_to_tele)))
  popuplib.delete('save_menu3')

def target_list4_select(userid, choice, popupid):
  user = int(choice)
  target = int(choice)
  target_list5 = popuplib.easymenu('target_list5', '_popup_choice', target_list5_select)
  target_list5.settitle("Player To Teleport:")
  for player in playerlib.getUseridList('#alive'):
    target_list5.addoption((target,int(player)),es.getplayername(player))
  target_list5.send(userid)
  popuplib.delete('target_list4')

def target_list5_select(userid, choice, popupid):
  user, choice = choice
  dict_teleport[user]["spot"] = es.getplayerlocation(user)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(choice), dict_teleport[user]["spot"][0], dict_teleport[user]["spot"][1], dict_teleport[user]["spot"][2]))
  if global_msg == 1:
    es.msg('#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported #lightgreen%s #defaultto #lightgreen%s#default!'%(es.getplayername(int(userid)),es.getplayername(int(choice)),es.getplayername(user)))
  else:
    es.tell(choice, '#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported you to #lightgreen%s#default!'%(es.getplayername(int(userid)),es.getplayername(user)))
    es.tell(user, '#multi', '#default[#greenTeleport#default]: Admin #lightgreen%s #defaultteleported #lightgreen%s #defaultto you!'%(es.getplayername(int(userid)),es.getplayername(int(choice))))
  es.setplayerprop(user, 'CBaseEntity.m_CollisionGroup', 2)
  es.setplayerprop(int(choice), 'CBaseEntity.m_CollisionGroup', 2)
  gamethread.delayed(5, unblock_player2, (user, choice))
  popuplib.delete('target_list5')

def unblock_player(userid, choice):
  es.setplayerprop(int(choice), 'CBaseEntity.m_CollisionGroup', 0)
  es.setplayerprop(int(userid), 'CBaseEntity.m_CollisionGroup', 0)

def unblock_player2(user, choice):
  es.setplayerprop(int(user), 'CBaseEntity.m_CollisionGroup', 0)
  es.setplayerprop(int(choice), 'CBaseEntity.m_CollisionGroup', 0)

def round_freeze_end(ev):
  for userid in playerlib.getUseridList('#alive'):
    user = int(userid)
    steamid = es.getplayersteamid(user)
    if steamid in admin_list or isAuthed(user):
      if dict_teleport[user]["loc1"] != 0 or dict_teleport[user]["loc2"] != 0 or dict_teleport[user]["loc3"] != 0:
        if dict_auto[user]["status"] != 0:
          if dict_auto[user]["status"] == 1:
            es.server.queuecmd('es_setpos %s %s %s %s'%(user, dict_teleport[user]["loc1"][0], dict_teleport[user]["loc1"][1], dict_teleport[user]["loc1"][2]))
          elif dict_auto[user]["status"] == 2:
            es.server.queuecmd('es_setpos %s %s %s %s'%(user, dict_teleport[user]["loc2"][0], dict_teleport[user]["loc2"][1], dict_teleport[user]["loc2"][2]))
          elif dict_auto[user]["status"] == 3:
            es.server.queuecmd('es_setpos %s %s %s %s'%(user, dict_teleport[user]["loc3"][0], dict_teleport[user]["loc3"][1], dict_teleport[user]["loc3"][2]))

def es_map_start(ev):
  global dict_teleport, dict_auto
  dict_teleport = {}
  dict_auto = {}

def player_activate(ev):
  user = int(ev['userid'])
  steamid = ev['es_steamid']
  dict_add_player(user, steamid)

def player_disconnect(ev):
  user = int(ev['userid'])
  steamid = ev['networkid']
  dict_del_player(user, steamid)

def dict_add_player(user, steamid):
  global dict_teleport, dict_auto
  if steamid in admin_list or isAuthed(user):
    if user not in dict_teleport:
      dict_teleport[user] = {}
      dict_teleport[user]["loc1"] = 0
      dict_teleport[user]["loc2"] = 0
      dict_teleport[user]["loc3"] = 0
      dict_teleport[user]["spot"] = 0
      dict_teleport[user]["player"] = 0
    if user not in dict_auto:
      dict_auto[user] = {}
      dict_auto[user]["status"] = 0
  else:
    if user not in dict_teleport:
      dict_teleport[user] = {}
      dict_teleport[user]["spot"] = 0

def dict_del_player(user, steamid):
  if user in dict_teleport:
    del dict_teleport[user]
  if user in dict_auto:
    del dict_auto[user]

def unload():
  if es.exists('saycommand', '!teleport'):
    es.unregsaycmd('!teleport')
  for user in es.getUseridList():
    steamid = es.getplayersteamid(user)
    dict_del_player(user, steamid)
  es.msg('#multi', '#default[#greenTeleport#default] by #lightgreenUndead #defaulthas been loaded!')